var CarFigureLayer = cc.Layer.extend({
    sprite_background: null,

    arry_carband_sequence: null,

    sprite_car_center: null,

    arry_sprite_cars: null,

    arry_car_begin_position: null,
    car_end_position: null,

    car_name_end_position: null,
    car_name_begin_position: null,
    sprite_car_name: null,

    sprite_name_back: null,
    name_back_begin_position: null,
    name_back_end_position: null,

    sprite_monkey: null,

    sprite_select: null,

    menu_item_replay: null,

    sprite_listener0: null,
    sprite_listener1: null,
    sprite_listener2: null,
    sprite_listener3: null,

    n_cur_step: null,

    menu_turn: null,

    star_ad: null,

//    id_music_introduction:null,

    ctor: function () {
        //////////////////////////////
        // 1. super init first
        this._super();
        var self = this;
        cc.eventManager.addListener({
            event: cc.EventListener.KEYBOARD,
            onKeyReleased: function (keyCode, event) {
                if (keyCode == cc.KEY.back) {
                    ddStopAllEffect();
                    cc.director.popScene();
                    self.cleanScene();
                } else if (keyCode == cc.KEY.menu) {

                }
            }
        }, this);

        var size = cc.winSize;

        this.initConfig();

        this.sprite_background = new cc.Sprite("res/game2/background.jpg");
        this.sprite_background.x = size.width / 2;
        this.sprite_background.y = size.height / 2;
        this.sprite_background.scaleX = widthRatio;
        this.addChild(this.sprite_background, 0);

        this.sprite_car_center = new CarSprite(getBackPath(this.arry_carband_sequence[this.n_cur_step]));
        this.sprite_car_center.x = (size.width - 110) / 2 - 40;
        this.sprite_car_center.y = size.height / 2 + 40;
        this.addChild(this.sprite_car_center, 1);

        this.sprite_car_name = new cc.Sprite(getCNamePath(this.arry_carband_sequence[this.n_cur_step]));
        this.sprite_car_name.x = this.car_name_begin_position.x;
        this.sprite_car_name.y = this.car_name_begin_position.y;
        this.sprite_car_name.scale = 0.7;
        this.addChild(this.sprite_car_name, 3);

        this.sprite_name_back = new cc.Sprite("res/game2/name_back.png");
        this.sprite_name_back.x = this.name_back_begin_position.x;
        this.sprite_name_back.y = this.name_back_begin_position.y;
        this.addChild(this.sprite_name_back, 2);

        this.arry_sprite_cars = [null, null, null, null];
        for (var n_index = 0; n_index < 4; ++n_index) {
            this.arry_sprite_cars[n_index] = new CarSprite(getNormalPath(this.arry_carband_sequence[this.n_cur_step]));
            this.arry_sprite_cars[n_index].x = this.arry_car_begin_position[n_index].x;
            this.arry_sprite_cars[n_index].y = this.arry_car_begin_position[n_index].y;
            this.arry_sprite_cars[n_index].scale = 0.4;
            this.addChild(this.arry_sprite_cars[n_index], 5 + n_index);
        }

        var arry_menu_item = [];
        var backItem = new cc.MenuItemImage(
            "res/RetBtnNormal.png",
            "res/ReturnBtnHigh.png",
            function () {
                ddStopAllEffect();
                cc.director.popScene();
                self.cleanScene();
            }, this);
        backItem.attr({
            x: isFullScreenDevice() ? 170 : 70,
            y: size.height - 70,
            anchorX: 0.5,
            anchorY: 0.5
        });
        arry_menu_item[0] = backItem;

        this.menu_item_replay = new cc.MenuItemImage(
            "res/RetryBtnNormal.png",
            "res/RetryBtnHigh.png",
            function () {
                ddStopAllEffect();

                this.initConfig();
                this.sprite_monkey.stopAllActions();
                this.sprite_monkey.setVisible(false);
                this.menu_item_replay.setVisible(false);
                this.reshuffleGame();
            }, this);
        this.menu_item_replay.attr({
            x: (size.width - 110) / 2 - 40,
            y: 120,
            anchorX: 0.5,
            anchorY: 0.5
        });
        arry_menu_item[1] = this.menu_item_replay;
        this.menu_item_replay.setVisible(false);

        var menu = new cc.Menu(arry_menu_item);
        menu.x = 0;
        menu.y = 0;
        this.addChild(menu, 10);

        this.sprite_monkey = new cc.Sprite("res/game1/wave/1.png");
        this.sprite_monkey.x = this.car_end_position.x;
        this.sprite_monkey.y = this.car_end_position.y;
        this.sprite_monkey.setVisible(false);
        this.addChild(this.sprite_monkey, 11);

        var sprite_listener = cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: function (touch, event) {
                var target = event.getCurrentTarget();
                var locationInNode = target.convertToNodeSpace(touch.getLocation());

                var s = target.getContentSize();
                var rect = cc.rect(0, 0, s.width, s.height);

                if (cc.rectContainsPoint(rect, locationInNode)) {
                    target.runAction(cc.ScaleTo(0.02, 0.5, 0.5));
                    self.sprite_select = target;
                    return true;
                }
                return false;
            },
            onTouchMoved: function (touch, event) {
//                var target = event.getCurrentTarget();
                var delta = touch.getDelta();
                self.sprite_select.x += delta.x;
                self.sprite_select.y += delta.y;
                var total_length = cc.winSize.width - 110 - self.car_end_position.x;
                var cur_length = cc.winSize.width - 110 - self.sprite_select.x;

                var scale_result = 0.5 + 0.5 * cur_length / (total_length * 1.0);
                scale_result = scale_result > 1.0 ? 1.0 : scale_result;
                scale_result = scale_result < 0.5 ? 0.5 : scale_result;

                self.sprite_select.scale = scale_result;
            },
            onTouchEnded: function (touch, event) {
//                var target = event.getCurrentTarget();

                if (self.isSpriteShouldDraw(self.sprite_car_center, self.sprite_select)) {
//                	ddPlayEffect('', "res/sound/right.mp3", false);
                    self.sprite_select.x = self.car_end_position.x;
                    self.sprite_select.y = self.car_end_position.y;
                    self.sprite_select.runAction(cc.scaleTo(0.1, 1));
                    self.pauseAllTarget();
                    for (var n_index = 0; n_index < 4; ++n_index) {
                        if (self.sprite_select != self.arry_sprite_cars[n_index]) {
                            self.arry_sprite_cars[n_index].runAction(cc.fadeTo(0.2, 0));
                        }
                    }

                    self.showNameAnimation();

                } else {
                    ddPlayEffect('', "res/sound/wrong.mp3", false);
                    self.arry_sprite_cars[0].x = self.arry_car_begin_position[0].x;
                    self.arry_sprite_cars[0].y = self.arry_car_begin_position[0].y;
                    self.arry_sprite_cars[1].x = self.arry_car_begin_position[1].x;
                    self.arry_sprite_cars[1].y = self.arry_car_begin_position[1].y;
                    self.arry_sprite_cars[2].x = self.arry_car_begin_position[2].x;
                    self.arry_sprite_cars[2].y = self.arry_car_begin_position[2].y;
                    self.arry_sprite_cars[3].x = self.arry_car_begin_position[3].x;
                    self.arry_sprite_cars[3].y = self.arry_car_begin_position[3].y;
                    self.arry_sprite_cars[0].runAction(cc.scaleTo(0.01, 0.4, 0.4));
                    self.arry_sprite_cars[1].runAction(cc.scaleTo(0.01, 0.4, 0.4));
                    self.arry_sprite_cars[2].runAction(cc.scaleTo(0.01, 0.4, 0.4));
                    self.arry_sprite_cars[3].runAction(cc.scaleTo(0.01, 0.4, 0.4));
                }
            }
        });

        this.sprite_listener0 = sprite_listener.clone();
        this.sprite_listener0.retain();
        this.sprite_listener1 = sprite_listener.clone();
        this.sprite_listener1.retain();
        this.sprite_listener2 = sprite_listener.clone();
        this.sprite_listener2.retain();
        this.sprite_listener3 = sprite_listener.clone();
        this.sprite_listener3.retain();

        this.reshuffleGame();

        if (ARRY_AD_IN && ARRY_AD_IN.length) {
            if (AD_ENABLE) {
                showStarAd(this, this.star_ad, cc.p(60, -20));
            }
        }

        return true;
    },

    reshuffleGame: function () {
//        this.n_cur_step = this.n_cur_step % 16;
//    	if(this.n_cur_step >= 10){
        if (this.n_cur_step >= this.arry_carband_sequence.length) {
            this.showSuccessAnimation();
            return;
        }

        var arry_cars_temp = this.arry_carband_sequence.slice(0);
        arry_cars_temp.splice(this.n_cur_step, 1);
        arry_cars_temp.reshuffle();
        arry_cur_cars = [this.arry_carband_sequence[this.n_cur_step], arry_cars_temp[0], arry_cars_temp[1], arry_cars_temp[2]];
        arry_cur_cars.reshuffle();
        for (var n_index = 0; n_index < 4; ++n_index) {
            this.arry_sprite_cars[n_index].setTexture(getNormalPath(arry_cur_cars[n_index]));
            this.arry_sprite_cars[n_index].setCarName(arry_cur_cars[n_index]);
            this.arry_sprite_cars[n_index].x = this.arry_car_begin_position[n_index].x;
            this.arry_sprite_cars[n_index].y = this.arry_car_begin_position[n_index].y;
            this.arry_sprite_cars[n_index].scale = 0.4;
            this.arry_sprite_cars[n_index].opacity = 0;
            this.arry_sprite_cars[n_index].setVisible(true);
        }

        this.sprite_car_center.opacity = 0;

        this.sprite_car_name.x = this.car_name_begin_position.x;
        this.sprite_car_name.y = this.car_name_begin_position.y;
        this.sprite_car_name.setTexture(getCNamePath(this.arry_carband_sequence[this.n_cur_step]));

        this.sprite_name_back.x = this.name_back_begin_position.x;
        this.sprite_name_back.y = this.name_back_begin_position.y;

        this.sprite_car_center.setTexture(getBackPath(this.arry_carband_sequence[this.n_cur_step]));
        this.sprite_car_center.setCarName(this.arry_carband_sequence[this.n_cur_step]);

        this.sprite_car_name.setVisible(true);

//        this.id_music_car_name = ddPlayEffect("", "res/sound/" + this.arry_car_sequence[this.n_cur_step] + ".mp3", false);
        this.sprite_car_center.runAction(cc.fadeTo(0.2, 255));
        this.arry_sprite_cars[0].runAction(cc.FadeTo(0.2, 255));
        this.arry_sprite_cars[1].runAction(cc.FadeTo(0.2, 255));
        this.arry_sprite_cars[2].runAction(cc.FadeTo(0.2, 255));
        this.arry_sprite_cars[3].runAction(cc.Sequence.create(cc.FadeTo(0.3, 255), cc.CallFunc.create(function () {
            this.resumeAllTarget();
        }.bind(this))));
    },
    initConfig: function () {
        var size = cc.winSize;
        this.n_cur_step = 0;
        this.arry_carband_sequence = getCarArray();
        this.arry_carband_sequence.reshuffle();
        this.arry_car_begin_position = [cc.p(size.width - 110 * widthRatio, 560),
            cc.p(size.width - 110 * widthRatio, 400),
            cc.p(size.width - 110 * widthRatio, 240),
            cc.p(size.width - 110 * widthRatio, 80)];
        this.car_end_position = cc.p((size.width - 110) / 2 - 40, size.height / 2 + 40);
        this.name_back_begin_position = cc.p((size.width / 2 - 100), -105);
        this.name_back_end_position = cc.p((size.width / 2 - 100), 105);
        this.car_name_begin_position = cc.p((size.width / 2 - 100), -90);
        this.car_name_end_position = cc.p((size.width / 2 - 100), 90);

    },
    isSpriteShouldDraw: function (sprite_target, sprite_src) {
        if ((sprite_target.getCarName() == sprite_src.getCarName()) && cc.rectIntersectsRect(sprite_src.getBoundingBox(), sprite_target.getBoundingBox())) {
            return true;
        }

        return false;
    },

    pauseAllTarget: function () {
        cc.eventManager.removeListener(this.sprite_listener0);
        cc.eventManager.removeListener(this.sprite_listener1);
        cc.eventManager.removeListener(this.sprite_listener2);
        cc.eventManager.removeListener(this.sprite_listener3);
    },
    resumeAllTarget: function () {
        cc.eventManager.addListener(this.sprite_listener0, this.arry_sprite_cars[0]);
        cc.eventManager.addListener(this.sprite_listener1, this.arry_sprite_cars[1]);
        cc.eventManager.addListener(this.sprite_listener2, this.arry_sprite_cars[2]);
        cc.eventManager.addListener(this.sprite_listener3, this.arry_sprite_cars[3]);
    },
    showSuccessAnimation: function () {

        this.sprite_car_center.opacity = 0;
        this.arry_sprite_cars[0].opacity = 0;
        this.arry_sprite_cars[1].opacity = 0;
        this.arry_sprite_cars[2].opacity = 0;
        this.arry_sprite_cars[3].opacity = 0;

        this.sprite_car_name.x = this.car_name_begin_position.x;
        this.sprite_car_name.y = this.car_name_begin_position.y;
        this.sprite_name_back.x = this.name_back_begin_position.x;
        this.sprite_name_back.y = this.name_back_begin_position.y;

        ddPlayEffect('', "res/sound/success.mp3", false);

        this.menu_item_replay.setVisible(true);

        this.sprite_monkey.setVisible(true);
        var animal_animation = new cc.Animation.create();
        animal_animation.setDelayPerUnit(0.07);
        animal_animation.setRestoreOriginalFrame(true);
        for (var index = 1; index < 18; ++index) {
            animal_animation.addSpriteFrameWithFile("res/game1/wave/" + index + ".png");
        }

        var animation_blind = new cc.Animation.create();
        animation_blind.setDelayPerUnit(0.07);
        animation_blind.setRestoreOriginalFrame(true);
        for (var index = 1; index < 19; ++index) {
            animation_blind.addSpriteFrameWithFile("res/game1/blind/" + index + ".png");
        }
        this.sprite_monkey.runAction(cc.RepeatForever.create(cc.Sequence.create(cc.Animate.create(animation_blind), cc.Animate.create(animal_animation))));
    },
    showNameAnimation: function () {
        this.sprite_car_name.stopAllActions();
        this.sprite_name_back.stopAllActions();
        this.scheduleOnce(function () {
            ddPlayEffect('', getCSoundPath(this.arry_carband_sequence[this.n_cur_step]), 0);
        }.bind(this), 0.2);
        this.sprite_car_name.runAction(cc.Sequence.create(cc.moveTo(0.2, this.car_name_end_position),
            cc.moveBy(0.1, cc.p(0, -20)), cc.moveBy(0.1, cc.p(0, 20)),
            cc.moveBy(0.1, cc.p(0, -12)), cc.moveBy(0.1, cc.p(0, 12)),
            cc.moveBy(0.1, cc.p(0, -8)), cc.moveBy(0.1, cc.p(0, 8))));
        this.sprite_name_back.runAction(cc.Sequence.create(cc.moveTo(0.2, this.name_back_end_position),
            cc.moveBy(0.1, cc.p(0, -20)), cc.moveBy(0.1, cc.p(0, 20)),
            cc.moveBy(0.1, cc.p(0, -12)), cc.moveBy(0.1, cc.p(0, 12)),
            cc.moveBy(0.1, cc.p(0, -8)), cc.moveBy(0.1, cc.p(0, 8)),
            cc.DelayTime.create(2),
            cc.CallFunc.create(function () {
                this.n_cur_step++;
                this.reshuffleGame();
            }.bind(this))));
    },
    cleanScene: function () {
        releaseObj(this.animation_monkey);
        releaseObj(this.sprite_listener0);
        releaseObj(this.sprite_listener1);
        releaseObj(this.sprite_listener2);
        releaseObj(this.sprite_listener3);
    }
});

var CarFigureScene = cc.Scene.extend({
    ctor: function () {
        this._super();
    },
    onEnter: function () {
        this._super();
        var layer = new CarFigureLayer();
        this.addChild(layer);
    }
});

