
var CarHomeLayer = cc.Layer.extend({
	sprite_forest:null,
	forest_begin_position:null,
	forest_end_position:null,
	
	sprite_ground:null,
	ground_begin_position:null,
	ground_end_position:null,
	
	sprite_decorate:null,
	
    sprite_title:null,
    title_begin_position:null,
    title_end_position:null,
    
    sprite_wood:null,
    wood_begin_position:null,
    wood_end_position:null,
    
    arry_menu_sequence:null,
    arry_sprite_menu:null,
    arry_menu_begin_position:null,
    arry_menu_end_position:null,
    
    band_begin_position:null,
    band_end_position:null,
    
    sprite_monkey:null,
    monkey_begin_position:null,
    monkey_end_position:null,
    
    sprite_step:null,
    step_begin_position:null,
    step_end_position:null,
                                     
    sprite_listener0:null,
    sprite_listener1:null,
    sprite_listener2:null,
    
    animation_monkey:null,
            
    menu_turn:null,
                                   
    star_ad:null,
                                    
//    id_music_introduction:null,
    
    ctor:function () {
        //////////////////////////////
        // 1. super init first
        this._super();
        var self = this;
        cc.eventManager.addListener({
        	event: cc.EventListener.KEYBOARD,
        	onKeyReleased: function(keyCode, event) {
        		if (keyCode == cc.KEY.back) {
                    ddStopAllEffect();
                    cc.director.popToRootScene();
                    self.cleanScene();
        		}
        		else if (keyCode == cc.KEY.menu) {

        		}
        	}}, this);
        
        var size = cc.winSize;
                                    
        this.initConfig();
                                      
        this.sprite_background = new cc.Sprite("res/home/background.jpg");
        this.sprite_background.x = size.width / 2;
        this.sprite_background.y = size.height / 2;
        this.sprite_background.scaleX = widthRatio;
        this.addChild(this.sprite_background, 0);
        
        this.sprite_decorate = new cc.Sprite("res/home/decorate.png");
        this.sprite_decorate.x = size.width / 2;
        this.sprite_decorate.y = size.height - 200;
        this.sprite_decorate.opacity = 0;
        this.sprite_decorate.scaleX = widthRatio;
        this.addChild(this.sprite_decorate, 1);
        
        this.sprite_forest = new cc.Sprite("res/home/forest.png");
        this.sprite_forest.x = this.forest_begin_position.x;
        this.sprite_forest.y = this.forest_begin_position.y;
        this.sprite_forest.scaleX = widthRatio;
        this.addChild(this.sprite_forest, 2);
        
        this.sprite_ground = new cc.Sprite("res/home/ground.png");
        this.sprite_ground.x = this.ground_begin_position.x;
        this.sprite_ground.y = this.ground_begin_position.y;
        this.addChild(this.sprite_ground, 3);
        
        this.sprite_wood = new cc.Sprite("res/home/wood.png");
        this.sprite_wood.x = this.wood_begin_position.x;
        this.sprite_wood.y = this.wood_begin_position.y;
        this.addChild(this.sprite_wood, 5);
        
        this.sprite_monkey = new cc.Sprite("res/home/car.png");
        this.sprite_monkey.x = this.monkey_begin_position.x;
        this.sprite_monkey.y = this.monkey_begin_position.y;
        this.addChild(this.sprite_monkey, 6);
                                     
        this.arry_sprite_menu = [null, null, null];
        for(var n_index = 0; n_index < 3; ++n_index){
        	this.arry_sprite_menu[n_index] = new cc.Sprite(getMenuPath(this.arry_menu_sequence[n_index]));
        	this.arry_sprite_menu[n_index].x = this.arry_menu_begin_position[n_index].x;
        	this.arry_sprite_menu[n_index].y = this.arry_menu_begin_position[n_index].y;
        	this.addChild(this.arry_sprite_menu[n_index], 7 + n_index);
        }
        
        this.sprite_title = new cc.Sprite("res/home/title.png");
        this.sprite_title.x = this.title_begin_position.x;
        this.sprite_title.y = this.title_begin_position.y;
        this.addChild(this.sprite_title, 11);
                                     
        var arry_menu_item = [];
        var backItem = new cc.MenuItemImage(
        		"res/RetBtnNormal.png",
        		"res/ReturnBtnHigh.png",
        		function () {
                    ddStopAllEffect();
        			cc.director.popToRootScene();
                    self.cleanScene();
        		}, this);
        backItem.attr({
        	x: isFullScreenDevice()?170:70,
        	y: size.height - 70,
        	anchorX: 0.5,
        	anchorY: 0.5
        });
        arry_menu_item[0] = backItem;
                                     
        this.menu_item_replay = new cc.MenuItemImage(
            "res/RetryBtnNormal.png",
            "res/RetryBtnHigh.png",
            function () {
                ddStopAllEffect();

                this.initConfig();
                this.sprite_monkey.stopAllActions();
                this.sprite_monkey.setVisible(false);
                this.menu_item_replay.setVisible(false);
                this.reshuffleGame();
        }, this);
        this.menu_item_replay.attr({
            x: (size.width - 110) / 2 - 40,
            y: 120,
            anchorX: 0.5,
            anchorY: 0.5
        });
        arry_menu_item[1] = this.menu_item_replay;
        this.menu_item_replay.setVisible(false);
                                     
        var menu = new cc.Menu(arry_menu_item);
        menu.x = 0;
        menu.y = 0;
        this.addChild(menu, 12);
        
        this.animation_monkey = new cc.Animation.create();
        this.animation_monkey.setRestoreOriginalFrame(false);
        this.animation_monkey.setDelayPerUnit(0.05);
        for(var n_index = 1; n_index < 26; ++n_index){
        	this.animation_monkey.addSpriteFrameWithFile("res/home/car_animation/" + n_index + ".png");
        }
        this.animation_monkey.retain();
        
        this.sprite_step = new cc.Sprite("res/home/stage_" + getGameStage() + ".png");
        this.sprite_step.x = this.step_begin_position.x;
        this.sprite_step.y = this.step_begin_position.y;
        this.addChild(this.sprite_step, 13);

        var sprite_listener = cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: function (touch, event) {
                var target = event.getCurrentTarget();
                var locationInNode = target.convertToNodeSpace(touch.getLocation());
              
                var s = target.getContentSize();
                var rect = cc.rect(0, 0, s.width, s.height);
                  
                if (cc.rectContainsPoint(rect, locationInNode)) {
                	if (target == self.arry_sprite_menu[0]) {
                		cc.director.pushScene(new CarIntroScene());
                	} else if(target == self.arry_sprite_menu[1]){
                		cc.director.pushScene(new CarFigureScene());
                	}else if(target == self.arry_sprite_menu[2]){
                		cc.director.pushScene(new CarChooseScene());
					}
                    return false;
                }
                return false;
            },
            onTouchMoved: function (touch, event) {
                
            },
            onTouchEnded: function (touch, event) {
              
            }
        });

        this.sprite_listener0 = sprite_listener.clone();
        this.sprite_listener0.retain();
        this.sprite_listener1 = sprite_listener.clone();
        this.sprite_listener1.retain();
        this.sprite_listener2 = sprite_listener.clone();
        this.sprite_listener2.retain();  
        
        this.showGroundAnimation();
                                   
        if(ARRY_AD_IN && ARRY_AD_IN.length){
            if(AD_ENABLE){
                showStarAd(this, this.star_ad, cc.p(cc.winSize.width - 80, cc.winSize.height - 150));
            }
        }
        
        return true;
    },
    initConfig:function(){
        var size = cc.winSize;

        this.arry_menu_sequence = new Array("learn", "figure", "choose");
        
        this.arry_menu_begin_position = [
                                         cc.p(size.width + 200, size.height / 2 + 50),
                                         cc.p(size.width + 180, size.height / 3 + 25),
                                         cc.p(size.width + 200, 100)
                                         ];
        this.arry_menu_end_position = [
                                       cc.p(size.width - 200, size.height / 2 + 40),
                                       cc.p(size.width - 220, size.height / 3 + 17),
                                       cc.p(size.width - 200, 92)
                                       ];

        this.title_begin_position = cc.p(-340, size.height / 2 + 50);
        this.title_end_position = cc.p(size.width / 2 - 80, size.height * 2 / 3);
        
        this.wood_begin_position = cc.p(size.width - 220, -340);
        this.wood_end_position = cc.p(size.width - 220, 100);
        
        this.forest_begin_position = cc.p(size.width / 2, -170);
        this.forest_end_position = cc.p(size.width / 2, 168);
        
        this.ground_begin_position = cc.p(437.5, -100);
        this.ground_end_position = cc.p(437.5, 65);
        
        this.monkey_begin_position = cc.p(-260, 150);
        this.monkey_end_position = cc.p(size.width / 4 - 15, 135);
        
        this.step_begin_position = cc.p(size.width / 2 + 130, size.height + 100);
        this.step_end_position = cc.p(size.width / 2 + 130, size.height / 2 + 15);
    },
    
    pauseAllTarget:function(){
        cc.eventManager.removeListener(this.sprite_listener0);
        cc.eventManager.removeListener(this.sprite_listener1);
        cc.eventManager.removeListener(this.sprite_listener2);
    },
    resumeAllTarget:function(){
        cc.eventManager.addListener(this.sprite_listener0, this.arry_sprite_menu[0]);
        cc.eventManager.addListener(this.sprite_listener1, this.arry_sprite_menu[1]);
        cc.eventManager.addListener(this.sprite_listener2, this.arry_sprite_menu[2]);
    },
    showTitleAnimation:function(){
    	this.sprite_title.runAction(cc.Sequence.create(cc.moveTo(0.4, this.title_end_position).easing(cc.easeInOut(3)),
    			cc.moveBy(0.1, cc.p(30, 0)),
    			cc.moveBy(0.1, cc.p(-30, 0)),
    			cc.moveBy(0.1, cc.p(20, 0)),
    			cc.moveBy(0.1, cc.p(-20, 0)),
    			cc.moveBy(0.1, cc.p(10, 0)),
    			cc.moveBy(0.1, cc.p(-10, 0)),
    			cc.CallFunc.create(function(){
    				this.sprite_decorate.runAction(cc.Sequence.create(cc.delayTime(0.3), cc.fadeTo(0.3, 255), cc.CallFunc.create(function() {
						this.showStepAnimation();
					}.bind(this))))
    			}.bind(this))));
    },
    showGroundAnimation:function(){
    	ddPlayEffect('', "res/sound/title.mp3", false);
    	this.sprite_forest.runAction(cc.Sequence.create(cc.moveTo(0.5, this.forest_end_position).easing(cc.easeInOut(3)),
    			cc.moveBy(0.1, cc.p(0, 10)),
    			cc.moveBy(0.1, cc.p(0, -20)),
    			cc.moveBy(0.1, cc.p(0, 20)),
    			cc.moveBy(0.1, cc.p(0, -10))));
    	this.sprite_ground.runAction(cc.Sequence.create(cc.moveTo(0.5, this.ground_end_position).easing(cc.easeInOut(3)),
    			cc.moveBy(0.1, cc.p(0, 5)),
    			cc.moveBy(0.1, cc.p(0, -10)),
    			cc.moveBy(0.1, cc.p(0, 10)),
    			cc.moveBy(0.1, cc.p(0, -5)),
    			cc.CallFunc.create(function() {
					this.showTitleAnimation();
				}.bind(this))));
    },
    showWoodAnimation:function(){
    	this.sprite_wood.runAction(cc.Sequence.create(cc.moveTo(0.3, this.wood_end_position).easing(cc.easeInOut(3)),
    			cc.CallFunc.create(function() {
					this.showMenuAnimation(0);
					this.showMenuAnimation(1);
					this.showMenuAnimation(2);
				}.bind(this))));
    },
    showMenuAnimation:function(menu_index){
    	var time_interval = 0.1;
    	var ease_time = 0.3;
    	switch (menu_index) {
		case 0:
		{
			this.arry_sprite_menu[0].runAction(cc.Sequence.create(cc.moveTo(ease_time, this.arry_menu_end_position[0]).easing(cc.easeInOut(3)),
					cc.scaleTo(time_interval, 1.2, 1.2),
					cc.scaleTo(time_interval, 0.8, 0.8),
					cc.scaleTo(time_interval, 1.1, 1.1),
					cc.scaleTo(time_interval, 0.9, 0.9),
					cc.scaleTo(time_interval, 1.0, 1.0)));
			break;
		}
		case 1:
		{
			this.arry_sprite_menu[1].runAction(cc.Sequence.create(cc.DelayTime.create(ease_time * 1 + 5 * time_interval * 1), 
					cc.moveTo(ease_time, this.arry_menu_end_position[1]).easing(cc.easeInOut(3)),
					cc.scaleTo(time_interval, 1.2, 1.2),
					cc.scaleTo(time_interval, 0.8, 0.8),
					cc.scaleTo(time_interval, 1.1, 1.1),
					cc.scaleTo(time_interval, 0.9, 0.9),
					cc.scaleTo(time_interval, 1.0, 1.0)));
			break;
		}
		case 2:
		{
			this.arry_sprite_menu[2].runAction(cc.Sequence.create(cc.DelayTime.create(ease_time * 2 + 5 * time_interval * 2), 
					cc.moveTo(ease_time, this.arry_menu_end_position[2]).easing(cc.easeInOut(3)),
					cc.scaleTo(time_interval, 1.2, 1.2),
					cc.scaleTo(time_interval, 0.8, 0.8),
					cc.scaleTo(time_interval, 1.1, 1.1),
					cc.scaleTo(time_interval, 0.9, 0.9),
					cc.scaleTo(time_interval, 1.0, 1.0),
					cc.CallFunc.create(function() {
						this.resumeAllTarget();
					}.bind(this))));
			break;
		}
		default:
			break;
		}
    },
    showStepAnimation:function(){
    	this.sprite_step.stopAllActions();
    	this.sprite_step.runAction(cc.sequence(cc.moveTo(0.3, this.step_end_position).easing(cc.easeInOut(3)), 
    			cc.moveBy(0.2, cc.p(0, 30)),
    			cc.moveBy(0.2, cc.p(0, -30)),
    			cc.moveBy(0.2, cc.p(0, 20)),
    			cc.moveBy(0.2, cc.p(0, -20)),
    			cc.moveBy(0.2, cc.p(0, 10)),
    			cc.moveBy(0.2, cc.p(0, -10)),
    			cc.callFunc(function() {
    				this.showCarAnimation(0);
				}.bind(this))));
    },
    showCarAnimation:function(step){
    	switch (step) {
		case 0:
		{
			this.sprite_monkey.runAction(cc.Sequence.create(cc.moveTo(0.5, this.monkey_end_position).easing(cc.easeInOut(3)), 
					cc.CallFunc.create(function() {
						this.showCarAnimation(1);
						this.showWoodAnimation();
					}.bind(this))));
			break;
		}
		case 1:
		{
			
			this.sprite_monkey.runAction(cc.repeatForever(new cc.Animate(this.animation_monkey)));
			break;
		}
		default:
			break;
		}
    },
    cleanScene:function(){
        releaseObj(this.animation_monkey);
        releaseObj(this.sprite_listener0);
        releaseObj(this.sprite_listener1);
        releaseObj(this.sprite_listener2);
    }
});

var CarHomeScene = cc.Scene.extend({
    ctor:function(){
        this._super();
        var layer = new CarHomeLayer();
        this.addChild(layer);
        
        if(cc.sys.os != cc.sys.OS_ANDROID){
            ddPlayEffect('music', 'res/sound/bg_Music-1.mp3', true);
        }
    },
    onEnter:function () {
        this._super();
    }
});

