var isRequestPermission = false;
var GameSelectLayer = cc.Layer.extend({

    arry_menu_name: null,
    arry_menu_position: null,
    arry_sprite_menu: null,
    sprite_select: null,
    layer_quit: null,
    ad_view: null,
    star_ad: null,
    sprite_listener0: null,
    sprite_listener1: null,
    sprite_listener2: null,
    sprite_listener3: null,
    sprite_listener4: null,

//    id_music_introduction:null,

    ctor: function () {
        //////////////////////////////
        // 1. super init first
        this._super();

        var self = this;
        cc.eventManager.addListener({
            event: cc.EventListener.KEYBOARD,
            onKeyReleased: function (keyCode, event) {
                if (keyCode == cc.KEY.back) {
                    if(IS_WALL_SHOW){
                        dismissAppWallLayer();
                        return;
                    }
                    if(self.lock_ad){
                        self.lock_ad.removeFromParent(true);
                        self.lock_ad = null;
                        return;
                    }
                    if (self.layer_quit) {
                        self.layer_quit.removeFromParent(true);
                        self.layer_quit = null;
                    } else {
                        var ad_item = getQuitAd();
                        if (ad_item) {
                            self.layer_quit = new QuitAdViewLayer(function (action) {
                                switch (action) {
                                    case "quit": {
                                        ddStopAllEffect();
                                        quiteGame();
                                        break;
                                    }
                                    case "continue": {
                                        self.layer_quit.removeFromParent(true);
                                        self.layer_quit = null;
                                        break;
                                    }
                                    default:
                                        break;
                                }
                            }, ad_item);
                        } else {
                            self.layer_quit = new QuitViewLayer(function (action) {
                                switch (action) {
                                    case "quit": {
                                        ddStopAllEffect();
                                        quiteGame();
                                        break;
                                    }
                                    case "continue": {
                                        self.layer_quit.removeFromParent(true);
                                        self.layer_quit = null;
                                        break;
                                    }
                                    default:
                                        break;
                                }
                            });
                        }
                        self.addChild(self.layer_quit, 250);
                    }
                }
            }
        }, this);

        var size = cc.winSize;

        this.initConfig();

        this.sprite_background = new cc.Sprite("res/select/background.jpg");
        this.sprite_background.x = size.width / 2;
        this.sprite_background.y = size.height / 2;
        this.sprite_background.scaleX = widthRatio;
        this.addChild(this.sprite_background, 0);

        this.arry_sprite_menu = [null, null, null];
        for (var n_index = 0; n_index < 5; ++n_index) {
            this.arry_sprite_menu[n_index] = new cc.Sprite("res/select/" + this.arry_menu_name[n_index] + "_normal.png");
            this.arry_sprite_menu[n_index].x = this.arry_menu_position[n_index].x;
            this.arry_sprite_menu[n_index].y = this.arry_menu_position[n_index].y;
            this.arry_sprite_menu[n_index].scale = 0.65;
            this.addChild(this.arry_sprite_menu[n_index], 1 + n_index);
        }

        var self = this;
        var sprite_listener = cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: function (touch, event) {
                var target = event.getCurrentTarget();
                var locationInNode = target.convertToNodeSpace(touch.getLocation());

                var s = target.getContentSize();
                var rect = cc.rect(0, 0, s.width, s.height);

                if (cc.rectContainsPoint(rect, locationInNode)) {
                    self.sprite_select = target;
                    if (target == self.arry_sprite_menu[0]) {
                        target.setTexture("res/select/" + self.arry_menu_name[0] + "_select.png");
                    } else if (target == self.arry_sprite_menu[1] && !shouldShowLock()) {
                        target.setTexture("res/select/" + self.arry_menu_name[1] + "_select.png");
                    } else if (target == self.arry_sprite_menu[2]&& !shouldShowLock()) {
                        target.setTexture("res/select/" + self.arry_menu_name[2] + "_select.png");
                    } else if (target == self.arry_sprite_menu[3]) {
                        target.setTexture("res/select/" + self.arry_menu_name[3] + "_select.png");
                    }  else if (target == self.arry_sprite_menu[4]) {
                        target.setTexture("res/select/" + self.arry_menu_name[4] + "_select.png");
                    }
                    return true;
                }
                return false;
            },
            onTouchMoved: function (touch, event) {

            },
            onTouchEnded: function (touch, event) {
                if (shouldShowLock()) {
                    var target = event.getCurrentTarget();
                    if (target == self.arry_sprite_menu[1]) {
                        self.lock_ad = showLockAd(self)
                    } else if (target == self.arry_sprite_menu[2]) {
                        self.lock_ad = showLockAd(self)
                    } else {
                        self.checkCurSel(self.sprite_select);
                    }
                } else {
                    self.checkCurSel(self.sprite_select);
                }

            }
        });

        this.sprite_listener0 = sprite_listener.clone();
        this.sprite_listener0.retain();
        this.sprite_listener1 = sprite_listener.clone();
        this.sprite_listener1.retain();
        this.sprite_listener2 = sprite_listener.clone();
        this.sprite_listener2.retain();
        this.sprite_listener3 = sprite_listener.clone();
        this.sprite_listener3.retain();
        this.sprite_listener4 = sprite_listener.clone();
        this.sprite_listener4.retain();

         addPrivacyPolicyButton(this,"res/RetBtnNormal.png");

        cc.eventManager.addListener(this.sprite_listener0, this.arry_sprite_menu[0]);
        cc.eventManager.addListener(this.sprite_listener1, this.arry_sprite_menu[1]);
        cc.eventManager.addListener(this.sprite_listener2, this.arry_sprite_menu[2]);
        cc.eventManager.addListener(this.sprite_listener3, this.arry_sprite_menu[3]);
        cc.eventManager.addListener(this.sprite_listener4, this.arry_sprite_menu[4]);

        this.getAdConfig();



        if(!isRequestPermission){
           requestPermission();
           isRequestPermission = true;
        }
        return true;
    },
    getAdConfig: function () {
        this.getAdList(function () {
            if (AD_ENABLE) {
                this.ad_view = new AdViewLayer(ARRY_AD_HOME, cc.size(isFullScreenDevice()?220:140, cc.winSize.height));
                this.addChild(this.ad_view, 350);

                showStarAd(this, this.star_ad, cc.p(cc.winSize.width - 80, -20));
            }

            if (shouldShowLock()) {
                var lock1 = new cc.Sprite("res/adView/lock/lock");
                lock1.setPosition(this.arry_sprite_menu[1].getPosition());
                lock1.setScale(0.8);
                this.addChild(lock1, 200);

                var lock2 = new cc.Sprite("res/adView/lock/lock");
                lock2.setPosition(this.arry_sprite_menu[2].getPosition());
                lock2.setScale(0.8);
                this.addChild(lock2, 200);
            }

        }.bind(this));
    },
    getAdList: function (showAd) {
        if (!recommandEnable()) {
            AD_ENABLE = false;
            return;
        }


        getAdConfig("http://bb.shoujiduoduo.com/baby/game.php?act=sharelist&rid=10001&ver=1412" + "&isar=" + (cc.sys.os == cc.sys.OS_ANDROID ? 1 : 0), function () {
            var ad_value = cc.sys.localStorage.getItem("KEY_AD_LIST");

            if (ad_value) {
                var parse_result = JSON.parse(ad_value);
                AD_ENABLE = parse_result.enable;
                var ad_list = parse_result.list;
                var ad_in_list = parse_result.inads;
                var ad_quit_list = parse_result.quitads;
                var ad_lock_list = parse_result.lockads;
                if (null != ad_list) {
                    var AD_HOME_LIST = new Array(ad_list.length);
                    parseAdList(AD_HOME_LIST, ad_list);
                    ARRY_AD_HOME = filterAdInstall(AD_HOME_LIST, 3);
                    cc.log("home out ");
                    ARRY_AD_WALL = filterAndSortAdList(AD_HOME_LIST,ARRY_AD_HOME);

                }

                if (null != ad_in_list) {
                    var AD_IN_LIST = new Array(ad_in_list.length);
                    parseAdList(AD_IN_LIST, ad_in_list);
                    ARRY_AD_IN = filterAdInstall(AD_IN_LIST, 4);
                }

                if (null != ad_quit_list) {
                    var AD_QUIT_LIST = new Array(ad_quit_list.length);
                    parseAdList(AD_QUIT_LIST, ad_quit_list);
                    ARRY_AD_QUIT = filterAdInstall(AD_QUIT_LIST, 4);
                }
                if (null != ad_lock_list) {
                    cc.log("lock list");
                    var AD_LOCK_LIST = new Array();
                    parseAdList(AD_LOCK_LIST, ad_lock_list);
                    ARRY_AD_LOCK = lockAdNotInstall(AD_LOCK_LIST, 4);
                    cc.log("1111 " + ARRY_AD_LOCK);
                }

                showAd();
            }
        });
    },
    initConfig: function () {
        var size = cc.winSize;
        this.arry_menu_name = ["prior", "mid", "senior","short_video", "video"];
        this.arry_menu_position = [
            cc.p(size.width * 1 / 3 -100, size.height * 2 / 3 + 30),
            cc.p(size.width /2, size.height * 2 / 3 + 30),
            cc.p(size.width * 2 / 3 + 100, size.height * 2 / 3 + 30),
            cc.p(size.width * 1 / 3 -100, size.height / 3 - 30),
            cc.p(size.width /2, size.height / 3 - 30)
        ];
    },
    checkCurSel: function (target) {
        if (target == this.arry_sprite_menu[4]) {
            this.arry_sprite_menu[4].setTexture("res/select/" + this.arry_menu_name[4] + "_normal.png");
            playVideo();
            return;
        }

        if (target == this.arry_sprite_menu[3]) {
            this.arry_sprite_menu[3].setTexture("res/select/" + this.arry_menu_name[3] + "_normal.png");
            openShortVideoActivity();
            return;
        }
        if (target == this.arry_sprite_menu[0]) {
            this.arry_sprite_menu[0].setTexture("res/select/" + this.arry_menu_name[0] + "_normal.png");
            setGameStage(0);

        } else if (target == this.arry_sprite_menu[1]) {
            setGameStage(1);
            this.arry_sprite_menu[1].setTexture("res/select/" + this.arry_menu_name[1] + "_normal.png");
        } else if (target == this.arry_sprite_menu[2]) {
            setGameStage(2);
            this.arry_sprite_menu[2].setTexture("res/select/" + this.arry_menu_name[2] + "_normal.png");
        }

        this.sprite_select = null;
        cc.director.pushScene(new CarHomeScene());
    }
});

var GameSelectScene = cc.Scene.extend({
    ctor: function () {
        this._super();
        var layer = new GameSelectLayer();
        this.addChild(layer);
        cc.log("game select scene create");
        if (cc.sys.os != cc.sys.OS_ANDROID) {
            ddPlayEffect('music', 'res/sound/bg_Music-1.mp3', true);
        }

       showAdBanner(true,0.3,0);
    },
    onEnter: function () {
        this._super();
    }
});

