var IS_WALL_SHOW = false;
var TAG_AD_WALL = 9998;

AppListLayer = cc.LayerColor.extend({
    isScrolled:false,
    ctor: function () {
        this._super(cc.color(0, 0, 0, 0));
        IS_WALL_SHOW = true;

        this.setContentSize(cc.winSize);
        this.setAnchorPoint(0.5,0.5);
        this.setOpacity(128);

        let bg = new cc.Sprite(isPad()?"res/adView/wall/bg_pad.png":"res/adView/wall/bg_phone.png");
        this.addChild(bg);
        bg.setPosition(cc.winSize.width/2,cc.winSize.height/2);

        let width = bg.width;
        let height = bg.height;
        this.scrollView = new ccui.ScrollView();
        this.scrollView.setDirection(ccui.ScrollView.DIR_VERTICAL);
        this.scrollView.setContentSize(width, height - this.getHeadHeight());
        this.scrollView.setAnchorPoint(0.5,0.5);
        this.scrollView.setPosition(cc.winSize.width/2, cc.winSize.height/2-this.getHeadHeight()/2);
        this.scrollView.setTouchEnabled(true);
        this.scrollView.setScrollBarEnabled(false);
        this.scrollView.setBounceEnabled(true)
        this.addChild(this.scrollView);
        let margin = (width - this.getItemWidth() * 4) / 5;
        let h = this.getItemHeight() * Math.ceil(this.getItemNumber() / 4)
           + this.getVectialMargin() * Math.ceil(this.getItemNumber() / 4);

        if(h< height -this.getHeadHeight()){
            h = height - this.getHeadHeight();
        }
        this.scrollView.setInnerContainerSize(cc.size(width,h));

        let bg_title = new cc.Sprite("res/adView/wall/bg_title.png");
        bg_title.setPosition(width/2,height - 48);
        bg.addChild(bg_title);

        let title = new cc.LabelTTF("多多游戏课件", "Arial", 40);
        title.setFontFillColor(cc.color(255, 255, 255, 255));
        title.setPosition(width/2,height - 48);
        bg.addChild(title);

        let quit = new ccui.Button("res/adView/wall/quit.png","res/adView/wall/quit.png","");
        quit.setAnchorPoint(1,1);
        quit.setPosition(width - 20,height - 20);
        let self = this;
        quit.addClickEventListener(function () {
            self.removeFromParent(true);
            IS_WALL_SHOW = false;
        });
        bg.addChild(quit);

        for (let i = 0; i < this.getItemNumber(); i++) {
            let node = new cc.Node();
            let x = margin + (margin + this.getItemWidth()) * (i % 4);
            let y = h -  (this.getItemHeight() + this.getVectialMargin()) * Math.floor(i / 4);
            node.setPosition(x,y);
            this.scrollView.addChild(node);
            let sprite = new cc.Sprite(adResource("ad_back"));
            let ad = ARRY_AD_WALL[i];
            setWebImage(ad.getImage(),sprite);
            sprite.setAnchorPoint(0, 1);
            sprite.scale = 140/180;
            node.addChild(sprite);

            cc.eventManager.addListener(this.getAppTouchListener(ad),sprite);

            let label = new cc.LabelTTF(ad.getName(), "Arial", 22);

            label.setAnchorPoint(0, 1);
            label.setFontFillColor(cc.color(255, 255, 255, 255));
            let labelX = (this.getItemWidth() -label.width )/2;
            label.setPosition(labelX,-150);
            node.addChild(label);
        }

        cc.eventManager.addListener(this.getLayerTouchListener(),this);
    },

    getItemWidth: function () {
        return 140;
    },

    getItemHeight: function () {
        return 175;
    },
    getItemNumber: function () {
        return ARRY_AD_WALL== null ?0:ARRY_AD_WALL.length;
    },
    getVectialMargin:function () {
        return 30;
    },
    getHeadHeight:function () {
        return 96;
    },
    getLayerTouchListener:function () {
        let self = this;
        let listener = cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,

            onTouchBegan: function (touch, event) {
                if (touchInTarget(event.getCurrentTarget(), touch)) {
                    return true;
                }
                return false;
            },
            onTouchMoved: function (touch, event) {

            },
            onTouchEnded: function (touch, event) {
                if (touchInTarget(event.getCurrentTarget(), touch)) {
                    self.removeFromParent(true);
                    IS_WALL_SHOW = false;
                    return true;
                }
                return false;
            },

        });

        return listener;

    },
    getAppTouchListener:function (ad) {

        let self = this;
        this.scrollView.addEventListener(function (sender, type) {
            switch (type) {
                case ccui.ScrollView.EVENT_CONTAINER_MOVED:
                    self.isScrolled = true;
                    break
            }
        });
        let listener = cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: false,

            onTouchBegan: function (touch, event) {
                if (touchInTarget(event.getCurrentTarget(), touch)) {
                    self.isScrolled = false;
                    return true;
                }
                return false;
            },
            onTouchMoved: function (touch, event) {

            },
            onTouchEnded: function (touch, event) {
                if(!self.isScrolled){
                    if (touchInTarget(event.getCurrentTarget(), touch)) {
                        openMarket(ad);
                        umengEvent("more_app",ad.getName());
                        return true;
                    }
                }
                self.isScrolled = false;

                return false;
            },

        });

        return listener;

    },
});


function showAppWallLayer() {
    let layer = new AppListLayer();
    setAllNodeZOrder(layer,100);
    cc.director.getRunningScene().addChild(layer,0,TAG_AD_WALL);
    return layer;
}

function dismissAppWallLayer() {
    let layer =  cc.director.getRunningScene().getChildByTag(TAG_AD_WALL);
    if(layer != null){
        layer.removeFromParent(true);
    }
    IS_WALL_SHOW = false;
}

function setAllNodeZOrder(node,zOrder){
    node.setGlobalZOrder(zOrder);
    let children = node.getChildren();
    if(children != null){
        for(let i =0;i<children.length;i++){
            setAllNodeZOrder(children[i],zOrder);
        }
    }
}

var RandomNum = function (min, max) {
    var random = Math.floor(Math.random() * (max - min + 1) + min);
    cc.log("random int:" + random);
    return random;
};

var shakeNode= function (node) {
    var originScaleX = node.getScaleX();
    var originScaleY = node.getScaleY();
    node.runAction(cc.repeatForever(cc.sequence(
        cc.delayTime(2),
        cc.scaleTo(0.1, originScaleX * 1.1, originScaleY * 1.1),
        cc.scaleTo(0.1, originScaleX, originScaleY),
        cc.scaleTo(0.1, originScaleX * 1.1, originScaleY * 1.1),
        cc.scaleTo(0.1, originScaleX, originScaleY)
    )));
}

var touchInTarget = function (target, touch) {
    var locationInNode = target.convertTouchToNodeSpace(touch);
    var s = target.getContentSize();
    var rect = cc.rect(0, 0, s.width, s.height);
    return cc.rectContainsPoint(rect, locationInNode);
};