let AppName = '多多认车标';

function addPrivacyPolicyButton(layer, res_back_btn) {
    if (layer.privacy_policy) {
        return;
    }
    let privacy_policy = new ccui.Button('res/adView/privacy_policy.png');
    privacy_policy.scale = 0.6 * 640 / 750;
    let x = cc.winSize.width - (privacy_policy.width / 2 + 10) * privacy_policy.scale;
    let y = cc.winSize.height - (privacy_policy.height / 2 + 5) * privacy_policy.scale;
    privacy_policy.setPosition(layer.convertToNodeSpace(cc.p(x, y)));
    layer.addChild(privacy_policy, 1000);
    // cc.log('w : ' + privacy_policy.width + ', h : ' + privacy_policy.height);
    privacy_policy.setTouchEnabled(true);
    privacy_policy.addClickEventListener((event) => {
        // cc.log('run PrivacyPolicyScene');
       startPolicyActivity();
    });
    layer.privacy_policy = privacy_policy;
}

var PrivacyPolicyLayer = cc.LayerColor.extend({
    ctor: function (res_back_btn) {
        this._super(cc.color.WHITE);

        if(res_back_btn){
                let back_button = new ccui.Button(res_back_btn);
                back_button.x = back_button.width / 2;
                back_button.y = cc.winSize.height - back_button.height / 2 + 10;
                back_button.scale = 0.7;
                back_button.addClickEventListener(() => {
                    cc.director.popScene();
                });
                this.addChild(back_button, 1);
        }


        // this.p12 = p12;
        // this.scrollView = scrollView;
    },
    onEnter: function () {
        this._super();
        // let scrollView = this.scrollView;
        // let p12 = this.p12;
        let margin = 10;
        let innerSize = cc.size(cc.winSize.width - 2 * margin, cc.winSize.height * 4);
        let scrollView = new ccui.ScrollView();
        this.addChild(scrollView);
        scrollView.setContentSize(cc.size(innerSize.width, cc.winSize.height));
        scrollView.setDirection(cc.SCROLLVIEW_DIRECTION_VERTICAL);
        scrollView.setInnerContainerSize(innerSize);
        scrollView.x = margin;

        let content = "\n                                                                                  隐私政策\n\n\n" +
            AppName + "重视用户的隐私。您在使用我们的服务时，我们可能会收集和使用您的相关信息。我们希望通过本《隐私政策》向您说明，在使用我们的服务时，我们如何收集、使用、储存和分享这些信息，以及我们为您提供的访问、更新、控制和保护这些信息的方式。本《隐私政策》与您所使用的" + AppName + "服务息息相关，希望您仔细阅读，在需要时，按照本《隐私政策》的指引，作出您认为适当的选择。本《隐私政策》中涉及的相关技术词汇，我们尽量以简明扼要的表述，并提供进一步说明的链接，以便您的理解。\n" +
            "\n" +
            "您使用或继续使用我们的服务，即意味着同意我们按照本《隐私政策》收集、使用、储存和分享您的相关信息。\n" +
            "\n" +
            "我们可能收集的信息\n" +
            "我们提供服务时，可能会收集、储存和使用下列与您有关的信息。如果您不提供相关信息，可能无法注册成为我们的用户或无法享受我们提供的某些服务，或者无法达到相关服务拟达到的效果。\n" +
            "\n" +
            "我们收集数据是根据您与我们的互动和您所做出的选择，包括您的隐私设置以及您使用的产品和功能。我们收集的数据可能包括SDK/API/JS代码版本、浏览器、互联网服务提供商、IP地址、平台、时间戳、应用标识符、应用程序版本、应用分发渠道、独立设备标识符、iOS广告标识符（IDFA)、安卓广告主标识符、网卡（MAC）地址、国际移动设备识别码（IMEI）、设备型号、终端制造厂商、终端设备操作系统版本、会话启动/停止时间、语言所在地、时区和网络状态（WiFi等）、硬盘、CPU和电池使用情况等。\n" +
            "\n" +
            "您提供的信息\n" +
            "您在注册账户或使用我们的服务时，向我们提供的相关个人信息，例如电话号码、电子邮件等；\n" +
            "\n" +
            "您通过我们的服务向其他方提供的共享信息，以及您使用我们的服务时所储存的信息。\n" +
            "\n" +
            "我们获取的您的信息\n" +
            "您使用服务时我们可能收集如下信息：\n" +
            "\n" +
            "日志信息，指您使用我们的服务时，系统可能通过cookies、web beacon或其他方式自动采集的技术信息，包括：\n" +
            "\n" +
            "设备或软件信息，例如您的移动设备、网页浏览器或用于接入我们服务的其他程序所提供的配置信息、您的IP地址和移动设备所用的版本和设备识别码等； 在使用我们服务时搜索或浏览的信息，例如您使用的网页搜索词语、访问的社交媒体页面url地址，以及您在使用我们服务时浏览或要求提供的其他信息和内容详情；\n" +
            "有关您曾使用的移动应用（APP）和其他软件的信息，以及您曾经使用该等移动应用和软件的信息；\n" +
            "您通过我们的服务进行通讯的信息，例如曾通讯的账号，以及通讯时间、数据和时长；\n" +
            "您通过我们的服务分享的内容所包含的信息（元数据），例如拍摄或上传的共享照片或录像的日期、时间或地点等。\n" +
            "位置信息，指您开启设备定位功能并使用我们基于位置提供的相关服务时，收集的有关您位置的信息，包括：\n" +
            "\n" +
            "您通过具有定位功能的移动设备使用我们的服务时，通过GPS或WiFi等方式收集的您的地理位置信息；\n" +
            "您或其他用户提供的包含您所处地理位置的实时信息，例如您提供的账户信息中包含的您所在地区信息；\n" +
            "您可以通过关闭定位功能，停止对您的地理位置信息的收集。\n" +
            "我们可能如何使用信息\n" +
            "我们可能将在向您提供服务的过程之中所收集的信息用作下列用途：\n" +
            "\n" +
            "向您提供服务；\n" +
            "在我们提供服务时，用于身份验证、客户服务、安全防范、诈骗监测、存档和备份用途，确保我们向您提供的产品和服务的安全性；\n" +
            "帮助我们设计新服务，改善我们现有服务；\n" +
            "使我们更加了解您如何接入和使用我们的服务，从而针对性地回应您的个性化需求，例如语言设定、位置设定、个性化的帮助服务和指示，或对您和其他用户作出其他方面的回应；\n" +
            "向您提供与您更加相关的广告以替代普遍投放的广告；\n" +
            "软件认证或管理软件升级；\n" +
            "让您参与有关我们产品和服务的调查。\n" +
            "您如何访问和控制自己的个人信息\n" +
            "我们将尽一切可能采取适当的技术手段，保证您可以访问、更新、更正和删除自己的注册信息或使用我们的服务时提供的其他个人信息。在访问、更新、更正和删除前述信息时，我们可能会要求您进行身份验证，以保障账户安全。\n" +
            "\n" +
            "我们可能分享的信息\n" +
            "除以下情形外，未经您同意，我们以及我们的关联公司不会与任何第三方分享您的个人信息：\n" +
            "\n" +
            "我们以及我们的关联公司，可能将您的个人信息与我们的关联公司、合作伙伴及第三方服务供应商、承包商及代理（例如代表我们发出电子邮件或推送通知的通讯服务提供商、为我们提供位置数据的地图服务供应商）分享（他们可能并非位于您所在的法域），用作下列用途：1）向您提供我们的服务；2）实现“我们可能如何使用信息”部分所述目的；\n" +
            "\n" +
            "为了确保给您提供更好的服务，我们可能与第三方技术服务提供商（例如：推送技术服务提供商）共享您的信息，这些信息不包含您的任何身份识别信息。 在使用不包含您的任何身份识别信息的前提下，我们可能与第三方将相关的分析数据用于商业目的。\n" +
            "\n" +
            "如我们或我们的关联公司与任何上述第三方分享您的个人信息，我们将努力确保该等第三方在使用您的个人信息时遵守本《隐私政策》及我们要求其遵守的其他适当的保密和安全措施。\n" +
            "\n" +
            "信息安全\n" +
            "我们仅在本《隐私政策》所述目的所必需的期间和法律法规要求的时限内保留您的个人信息。\n" +
            "\n" +
            "我们使用各种安全技术和程序，以防信息的丢失、不当使用、未经授权阅览或披露。例如，在某些服务中，我们将利用加密技术（例如SSL）来保护您提供的个人信息。但请您理解，由于技术的限制以及可能存在的各种恶意手段，在互联网行业，即便竭尽所能加强安全措施，也不可能始终保证信息百分之百的安全。您需要了解，您接入我们的服务所用的系统和通讯网络，有可能因我们可控范围外的因素而出现问题。\n" +
            "\n" +
            "未成年人使用我们的服务\n" +
            "我们鼓励父母或监护人指导未满十八岁的未成年人使用我们的服务。我们建议未成年人鼓励他们的父母或监护人阅读本《隐私政策》，并建议未成年人在提交的个人信息之前寻求父母或监护人的同意和指导。\n" +
            "\n" +
            "隐私政策的适用范围\n" +
            "除某些特定服务外，我们所有的服务均适用本《隐私政策》。这些特定服务将适用特定的隐私政策。针对某些特定服务的特定隐私政策，将更具体地说明我们在该等服务中如何使用您的信息。该特定服务的隐私政策构成本《隐私政策》的一部分。如相关特定服务的隐私政策与本《隐私政策》有不一致之处，适用该特定服务的隐私政策。\n" +
            "\n" +
            "变更\n" +
            "我们可能适时修订本《隐私政策》的条款，该等修订构成本《隐私政策》的一部分。如该等修订造成您在本《隐私政策》下权利的实质减少，我们将在修订生效前通过在主页上显著位置提示或向您发送电子邮件或以其他方式通知您。在该种情况下，若您继续使用我们的服务，即表示同意受经修订的本《隐私政策》的约束。";
        let contentLabel = new cc.LabelTTF("" + content, 'Arial', 22);
        contentLabel.setDimensions(innerSize);
        contentLabel.setFontFillColor(cc.color.BLACK);
        contentLabel.x = contentLabel.width / 2 + margin;
        contentLabel.y = innerSize.height - contentLabel.height / 2;
        scrollView.addChild(contentLabel);


        cc.eventManager.addListener({
                    event: cc.EventListener.KEYBOARD,
                    onKeyReleased: function (keyCode, event) {
                        if (keyCode == cc.KEY.back) {
                            ddStopAllEffect();
                            cc.director.popScene();
                            self.cleanScene();
                        } else if (keyCode == cc.KEY.menu) {

                        }
                    }
              }, this);

    }


});

var PrivacyPolicyScene = cc.Scene.extend({
    ctor: function (res_back_btn) {
        this._super();

        let layer = new PrivacyPolicyLayer(res_back_btn);
        this.addChild(layer);
    }
});